using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using RNGClassLibrary;
using System.Data.Entity;
using System.Data.SqlClient;

namespace RNGWcfService1.ContextClass
{
    public class MetalDbContext:DbContext
    {
        public MetalDbContext() : base()
        {
            Database.SetInitializer<MetalDbContext>(null);
            base.Database.Connection.ConnectionString = System.Configuration.ConfigurationManager.ConnectionStrings["RNGConnectionStrings"].ConnectionString;
        }

        public System.Data.Entity.DbSet<MetalMaster> User { get; set; }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            modelBuilder.Entity<MetalMaster>().MapToStoredProcedures();
        }


        public void GetErrorDescription(int ErrorNo, ref string ErrorDesc)
        {
            var pErrCodeParam = new SqlParameter("pErrorNo", ErrorNo);

            var pErrDescParam = new SqlParameter("pErrorDesc", System.Data.SqlDbType.VarChar, 200);
            pErrDescParam.Direction = System.Data.ParameterDirection.Output;
            pErrDescParam.Value = "";

            this.Database.ExecuteSqlCommand("spErrors_GetErrorDesc @pErrorNo, @pErrorDesc out", pErrCodeParam, pErrDescParam);

            ErrorDesc = Convert.ToString(pErrDescParam.Value);
        }



        public virtual int MetalMaster_AddNew(string Metal_Name, string IsActive, string UserID, string FinalYear, string Status, ref string errorDesc)
        {
            errorDesc = "";

            var ReturnValueParam = new SqlParameter("@ReturnValue", System.Data.SqlDbType.Int);
            ReturnValueParam.Direction = System.Data.ParameterDirection.Output;

         

            var paramMetal_Name = new SqlParameter("pMetal_Name", Metal_Name);


            var paramIsActive = new SqlParameter("pIsActive", IsActive);

            var paramUserID = new SqlParameter("pUserID", UserID);

            var paramFinalYear = new SqlParameter("pFinalYear", FinalYear);

            var paramStatus = new SqlParameter("pStatus", Status);



            var dbContext = this.Database;

            using (var dbContextTransaction = dbContext.BeginTransaction())
            {
                int errorNo = 0;

                try
                {
                    dbContext.ExecuteSqlCommand("Exec @ReturnValue = Sp_MetalTypeMaster_AddNew @pMetal_Name,@pIsActive,@pUserID,@pFinalYear,@pStatus",
                                                ReturnValueParam,paramMetal_Name, paramIsActive, paramUserID, paramFinalYear, paramStatus);

                    errorNo = Convert.ToInt32(ReturnValueParam.Value);

                    if (errorNo >= 0) //**** Success
                    {
                        dbContextTransaction.Commit();
                        this.SaveChanges();
                    }
                    else //**** Error ****
                    {
                        dbContextTransaction.Rollback();
                        GetErrorDescription(errorNo, ref errorDesc);
                    }
                }
                catch (Exception ex)
                {
                    dbContextTransaction.Rollback();

                    errorNo = -1;
                    errorDesc = Convert.ToString(ex.Message);
                }
                return errorNo;
            }
        }

        public virtual int MetalMaster_Edit(int Metal_ID, string Metal_Name, string IsActive, string UserID, string FinalYear, string Status, ref string errorDesc)
        {
            errorDesc = "";

            var ReturnValueParam = new SqlParameter("@ReturnValue", System.Data.SqlDbType.Int);
            ReturnValueParam.Direction = System.Data.ParameterDirection.Output;

            var paramMetal_ID = new SqlParameter("pMetal_ID", Metal_ID);

            var paramMetal_Name = new SqlParameter("pMetal_Name", Metal_Name);

        
            var paramIsActive = new SqlParameter("pIsActive", IsActive);

            var paramUserID = new SqlParameter("pUserID", UserID);

            var paramFinalYear = new SqlParameter("pFinalYear", FinalYear);

            var paramStatus = new SqlParameter("pStatus", Status);



            var dbContext = this.Database;

            using (var dbContextTransaction = dbContext.BeginTransaction())
            {
                int errorNo = 0;

                try
                {
                    dbContext.ExecuteSqlCommand("Exec @ReturnValue = Sp_MetalTypeMaster_Edit @pMetal_ID,@pMetal_Name,@pIsActive,@pUserID,@pFinalYear,@pStatus",
                                                ReturnValueParam, paramMetal_ID,paramMetal_Name,paramIsActive, paramUserID, paramFinalYear, paramStatus);

                    errorNo = Convert.ToInt32(ReturnValueParam.Value);

                    if (errorNo >= 0) //**** Success
                    {
                        dbContextTransaction.Commit();
                        this.SaveChanges();
                    }
                    else //**** Error ****
                    {
                        dbContextTransaction.Rollback();
                        GetErrorDescription(errorNo, ref errorDesc);
                    }
                }
                catch (Exception ex)
                {
                    dbContextTransaction.Rollback();

                    errorNo = -1;
                    errorDesc = Convert.ToString(ex.Message);
                }
                return errorNo;
            }
        }



        public virtual List<MetalMaster> MetalMaster_GetAll(int Metal_ID)
        {
            var paramMetal_ID = new SqlParameter("pMetal_ID", Metal_ID);
      


            return this.Database.SqlQuery<MetalMaster>(
                            "Sp_MetalTypeMaster_GetAll @pMetal_ID",
                            paramMetal_ID).ToList();
        }


    }
}